FROM openshift/golang-builder:1.12 AS builder
ENV __doozer=update BUILD_RELEASE=202006081335 BUILD_VERSION=v4.3.25 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=25 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.25-202006081335 
ENV __doozer=merge OS_GIT_COMMIT=316991a OS_GIT_VERSION=4.3.25-202006081335-316991a SOURCE_DATE_EPOCH=1590611600 SOURCE_GIT_COMMIT=316991addd85f7e205526b26f65dbc94a47399c8 SOURCE_GIT_TAG=316991a SOURCE_GIT_URL=https://github.com/operator-framework/operator-registry 

RUN yum update -y && \
    yum install -y make git sqlite glibc-static openssl-static zlib-static && \
    yum groupinstall -y "Development Tools" "Development Libraries"

ENV GOPATH /go
ENV PATH $GOPATH/bin:/usr/local/go/bin:$PATH

WORKDIR /src

COPY vendor vendor
COPY cmd cmd
COPY pkg pkg
COPY Makefile go.mod go.sum ./
RUN make build

# copy and build vendored grpc_health_probe
RUN mkdir -p /go/src/github.com/grpc-ecosystem && \
    cp -R vendor/github.com/grpc-ecosystem/grpc-health-probe /go/src/github.com/grpc-ecosystem/grpc_health_probe && \
    cp -R vendor/ /go/src/github.com/grpc-ecosystem/grpc_health_probe && \
    cd /go/src/github.com/grpc-ecosystem/grpc_health_probe && \
    CGO_ENABLED=0 go install -a -tags netgo -ldflags "-w"

FROM openshift/ose-base:v4.3.25.20200608.133509
ENV __doozer=update BUILD_RELEASE=202006081335 BUILD_VERSION=v4.3.25 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=25 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.25-202006081335 
ENV __doozer=merge OS_GIT_COMMIT=316991a OS_GIT_VERSION=4.3.25-202006081335-316991a SOURCE_DATE_EPOCH=1590611600 SOURCE_GIT_COMMIT=316991addd85f7e205526b26f65dbc94a47399c8 SOURCE_GIT_TAG=316991a SOURCE_GIT_URL=https://github.com/operator-framework/operator-registry 

RUN mkdir /registry
WORKDIR /registry

COPY --from=builder /src/bin/initializer /bin/initializer
COPY --from=builder /src/bin/registry-server /bin/registry-server
COPY --from=builder /src/bin/configmap-server /bin/configmap-server
COPY --from=builder /src/bin/appregistry-server /bin/appregistry-server
COPY --from=builder /src/bin/opm /bin/opm
COPY --from=builder /go/bin/grpc_health_probe /bin/grpc_health_probe

RUN chgrp -R 0 /registry && \
    chmod -R g+rwx /registry

# This image doesn't need to run as root user
USER 1001

EXPOSE 50051

ENTRYPOINT ["/bin/registry-server"]
CMD ["--database", "/bundles.db"]

LABEL \
        io.k8s.display-name="OpenShift Operator Registry" \
        io.k8s.description="This is a component of OpenShift Operator Lifecycle Manager and is the base for operator catalog API containers." \
        maintainer="Odin Team <aos-odin@redhat.com>" \
        summary="Operator Registry runs in a Kubernetes or OpenShift cluster to provide operator catalog data to Operator Lifecycle Manager." \
        name="openshift/ose-operator-registry" \
        com.redhat.component="operator-registry-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        version="v4.3.25" \
        release="202006081335" \
        io.openshift.build.commit.id="316991addd85f7e205526b26f65dbc94a47399c8" \
        io.openshift.build.source-location="https://github.com/operator-framework/operator-registry" \
        io.openshift.build.commit.url="https://github.com/operator-framework/operator-registry/commit/316991addd85f7e205526b26f65dbc94a47399c8"

